#include "slicing.h"
#include "stdlib.h"
#include "stdio.h"

extern instr_info * iis[];     
extern Int always_traced;
int main (int argc, char ** argv)
{
     slice_node * criteria, * temp, * traced_cut, * t2;
     instr_info * ii;
     Int inst,i,idx, arg_idx;
     Int error_defined=0;
     Int step;
     Int forward=0;
     Char buf[1024];
     Int buf_idx=0;
     Int breadth_first=0;
     Int pid;
     Int data=0;

     //always_traced=1;
     printf("USAGE:slicing [-b] [-e error_file] pid  ii_1 inst_1 ii_2 inst_2 ii_3 inst_3 ...\n");
     if (argc<2) exit(-1);
     arg_idx=0;
     if (!strcmp(argv[1],"-e")) {
	error_defined=1;
	load_error_file(argv[2]);
	printf("load error done\n");
        arg_idx=2;
     } else if (!strcmp(argv[1],"-f")) {//forward slicing
        forward=1;
	arg_idx=1;
     } else if (!strcmp(argv[1],"-b")) {//breadth first search
        breadth_first=1;
        arg_idx=1;
     } else if (!strcmp(argv[1],"-d")) {//data slice
        data=1;
	arg_idx=1;
     }

     load_traced_file("./traced");
     pid=atoi(argv[arg_idx+1]);
     sprintf(buf,"SLICING.%d.instr_dic",pid);
     read_instr_dic(buf);
     printf("instr dic done\n");
     sprintf(buf,"SLICING.%d.pdg",pid);
     read_dependence(buf);
     printf("pdg done\n");
     //stat_executed_LOC();
     i=arg_idx+2;
     criteria=NULL;
     while (i<argc) {
        idx=atoi(argv[i]);
        ii=iis[idx];
	inst=atoi(argv[i+1]);
	//temp=create_slice_node(ii,inst);
        
        criteria=insert_node_into_list(ii, inst, criteria);
	i+=2;
     }    
     printf("criteria done\n");
     print_slice_list(criteria);
     if (!forward) {
	if (!data) {
	   sprintf(buf,"slice");
	
	   buf_idx=5;
        } else {
	   sprintf(buf,"slice_d");
	   buf_idx=7;
        }
     } else {
	sprintf(buf,"slice_f");
	buf_idx=7;
     }
     temp=criteria;
     while (temp) {
	   printf("%s\n",buf);
	   sprintf(buf+buf_idx,"_%d_%d",temp->ii->id, temp->inst);
	   buf_idx=strlen(buf);
	   temp=temp->next;
     }
     if (!forward) {
        if (!breadth_first) { 
           //traced_cut=slice_to_traced_cut(criteria);
           //printf("TRACED CUT:\n");
           //print_slice_list(traced_cut);
           //traced_cut=slice_from_traced_cut(traced_cut);
           if (!data) {
              traced_cut=slice_from_traced_cut(criteria);
           } else {
	      printf("DATA_SLICE\n");
	      traced_cut=data_slice(criteria);
           }
           printf("SORTING...\n");
           traced_cut=qsort_list(traced_cut);
           printf("SLICE:\n");
           print_slice_list(traced_cut);
	   printf("CONDENCED:\n");
	   print_slice_list_condensed(traced_cut);
        } else  {
	   temp=NULL;
	   t2=criteria;

	   while (t2) {
	       temp=insert_node_into_list(t2->ii,t2->inst,temp);
	       t2=t2->next;
           }
          /* 
           traced_cut=slice_from_breadth_first(criteria,&step);
	   traced_cut=qsort_list(traced_cut);
           printf("BS:\n");
	   print_slice_list(traced_cut);
           printf("CONDENSED BS:\n");
           print_slice_list_condensed(traced_cut);
           printf("STEP:%d",step);
           printf("NOW Sorting BS by DD: ...\n");
           traced_cut=qsort_list_by_dd_compact(traced_cut);
	   print_slice_list(traced_cut);
           */
           clear_all_visited_bits();
           printf("DS CRITERIA:\n");
           print_slice_list(temp);
           traced_cut=data_slice_breadth_first(temp,&step);
	   traced_cut=qsort_list(traced_cut);
           printf("DS:\n");
	   print_slice_list(traced_cut);
           printf("CONDENSED DS:\n");
           print_slice_list_condensed(traced_cut);
           printf("STEP:%d",step);
           printf("NOW Sorting DS by DD: ...\n");
           traced_cut=qsort_list_by_dd_compact(traced_cut);
	   print_slice_list(traced_cut);

        } 

     } else {//forward slicing
           printf("CONSTRUCTING ...\n");
	   construct_forward_pdg();
           traced_cut=forward_slice(criteria);
           printf("SORTING...\n");
           traced_cut=qsort_list(traced_cut);
           printf("SLICE:\n");
           print_slice_list(traced_cut);
	   printf("CONDENSED:\n"); 
           print_slice_list_condensed(traced_cut); 
     }    
     write_slice_list(buf, traced_cut);
}


